; CONSOLE #
include win64a.inc
BLACK   equ 0
BLUE    equ 1
GREEN   equ 2
CYAN    equ 3
RED equ 4
PURPLE  equ 5
YELLOW  equ 6
SYSTEM  equ 7
GREY    equ 8
BRIGHTBLUE equ 9
BRIGHTGREEN equ 10
BRIGHTCYAN equ 11
BRIGHTRED equ 12 
BRIGHTPURPLE equ 13
BRIGHTYELLOW equ 14
WHITE   equ 15
MAXSCREENX = 80
MAXSCREENY = 25
buffersize = 200
X = 0
Y = 10
.code
WinMain proc
local LENS:qword
local BUFF[buffersize]:byte
local ConsoleWindow:SMALL_RECT
 
	invoke  FreeConsole;release the existing console
        invoke  AllocConsole;create the console
        invoke  GetStdHandle,STD_OUTPUT_HANDLE;receive the handle for a conclusion
        mov	hOut,rax
	invoke  GetLargestConsoleWindowSize,eax
;   rax return in 31-16 bits: dwCoord.y
;                 15-00 bits: dwCoord.x
 
        lea	r8d,ConsoleWindow
	and	dword ptr [r8+SMALL_RECT.Left],0;mov [r8+SMALL_RECT.Left],0
						;mov [r8+SMALL_RECT.Top],0
 
	sub ax, MAXSCREENX
	sbb edx, edx
	and ax, dx
	add ax, MAXSCREENX-1
	mov [r8+SMALL_RECT.Right],ax
 
	shr eax, 16
	sub eax, MAXSCREENY
	sbb edx, edx
	and eax, edx
	add eax, MAXSCREENY-1
	mov [r8+SMALL_RECT.Bottom],ax
 
	invoke  SetConsoleWindowInfo,hOut,TRUE
 
	invoke  SetConsoleScreenBufferSize,hOut,MAXSCREENY*10000h+MAXSCREENX;establish the new size of a window of the console
	mov     ecx,offset STR2
	invoke  SetConsoleTitle     ;definition of a title bar
        invoke  SetConsoleCursorPosition,hOut,Y*10000h+X;establish a cursor position
        invoke  SetConsoleTextAttribute,hOut,BRIGHTGREEN ;set color attributes of the output text
        invoke  WriteConsole,hOut,&STR1,sizeof STR1,&BUFF,0 ;display a line of symbols
        invoke  GetStdHandle,STD_INPUT_HANDLE        ;receive HANDLE for input
        invoke  ReadConsole,eax,&BUFF,buffersize,&LENS,0     ;wait for input of a line of symbols
        invoke  SetConsoleTextAttribute,hOut,BRIGHTCYAN ;set color attributes of the output text
	lea     r9d,LENS
        mov     r8d,[r9]        ;length of the removed line
        invoke  WriteConsole,hOut,&BUFF,,,0
	invoke  Sleep,3000        ;small delay
        invoke  FreeConsole     ;close the console
	invoke	RtlExitUserProcess,NULL
WinMain endp
STR1	db 'Enter line of any symbols and press "Enter":',13,10
STR2	db 'Iczelion''s tutorial #38a',0
hOut	dq ?
end